/*!-----------------------------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * pxt-monaco-typescript version: 2.1.4(62a91d6246e497e373d45f8c19366cdf55d48c3c)
 * Released under the MIT license
 * https://github.com/Microsoft/pxt-monaco-typescript/blob/master/LICENSE.md
 *-----------------------------------------------------------------------------*/
define("vs/language/typescript/src/tokenization",["require","exports","../lib/typescriptServices"],function(e,t,n){"use strict";function r(e){var t=n.createClassifier(),r=e===a.TypeScript?c:l,i=e===a.TypeScript?u:p;return{getInitialState:function(){return new s(e,n.EndOfLineState.None,(!1))},tokenize:function(e,n){return o(r,i,t,n,e)}}}function o(e,t,r,o,c){function u(e,t,n){void 0===n&&(n=null),0!==l.tokens.length&&l.tokens[l.tokens.length-1].scopes===t||(n&&(t.indexOf("identifier")>-1||t.indexOf("keyword")>-1)?l.tokens.push({startIndex:e,scopes:t+" "+n}):l.tokens.push({startIndex:e,scopes:t}))}var l={tokens:[],endState:new s(o.language,n.EndOfLineState.None,(!1))},p=o.language===a.TypeScript;if(!p&&i(0,c,u))return l;var m=r.getClassificationsForLine(c,o.eolState,!0),d=0;l.endState.eolState=m.finalLexState,l.endState.inJsDocComment=m.finalLexState===n.EndOfLineState.InMultiLineCommentTrivia&&(o.inJsDocComment||/\/\*\*.*$/.test(c));for(var g=0,f=m.entries;g<f.length;g++){var h,v=f[g];if(v.classification===n.TokenClass.Punctuation){var S=c.charCodeAt(d);h=e[S]||t[v.classification],u(d,h)}else v.classification===n.TokenClass.Comment?l.endState.inJsDocComment||/\/\*\*.*\*\//.test(c.substr(d,v.length))?u(d,p?"comment.doc.ts":"comment.doc.js"):u(d,p?"comment.ts":"comment.js"):u(d,t[v.classification]||"",c.substr(d,v.length));d+=v.length}return l}function i(e,t,n){if(0===t.indexOf("#!"))return n(e,"comment.shebang"),!0}var a;!function(e){e[e.TypeScript=0]="TypeScript",e[e.EcmaScript5=1]="EcmaScript5"}(a=t.Language||(t.Language={})),t.createTokenizationSupport=r;var s=function(){function e(e,t,n){this.language=e,this.eolState=t,this.inJsDocComment=n}return e.prototype.clone=function(){return new e(this.language,this.eolState,this.inJsDocComment)},e.prototype.equals=function(t){return t===this||!!(t&&t instanceof e)&&(this.eolState===t.eolState&&this.inJsDocComment===t.inJsDocComment)},e}(),c=Object.create(null);c["(".charCodeAt(0)]="delimiter.parenthesis.ts",c[")".charCodeAt(0)]="delimiter.parenthesis.ts",c["{".charCodeAt(0)]="delimiter.bracket.ts",c["}".charCodeAt(0)]="delimiter.bracket.ts",c["[".charCodeAt(0)]="delimiter.array.ts",c["]".charCodeAt(0)]="delimiter.array.ts";var u=Object.create(null);u[n.TokenClass.Identifier]="identifier.ts",u[n.TokenClass.Keyword]="keyword.ts",u[n.TokenClass.Operator]="delimiter.ts",u[n.TokenClass.Punctuation]="delimiter.ts",u[n.TokenClass.NumberLiteral]="number.ts",u[n.TokenClass.RegExpLiteral]="regexp.ts",u[n.TokenClass.StringLiteral]="string.ts";var l=Object.create(null);l["(".charCodeAt(0)]="delimiter.parenthesis.js",l[")".charCodeAt(0)]="delimiter.parenthesis.js",l["{".charCodeAt(0)]="delimiter.bracket.js",l["}".charCodeAt(0)]="delimiter.bracket.js",l["[".charCodeAt(0)]="delimiter.array.js",l["]".charCodeAt(0)]="delimiter.array.js";var p=Object.create(null);p[n.TokenClass.Identifier]="identifier.js",p[n.TokenClass.Keyword]="keyword.js",p[n.TokenClass.Operator]="delimiter.js",p[n.TokenClass.Punctuation]="delimiter.js",p[n.TokenClass.NumberLiteral]="number.js",p[n.TokenClass.RegExpLiteral]="regexp.js",p[n.TokenClass.StringLiteral]="string.js"}),define("vs/language/typescript/src/workerManager",["require","exports"],function(e,t){"use strict";function n(e){var t,n,o=new r(function(e,r){t=e,n=r},function(){});return e.then(t,n),o}var r=monaco.Promise,o=function(){function e(e,t){var n=this;this._modeId=e,this._defaults=t,this._worker=null,this._idleCheckInterval=setInterval(function(){return n._checkIfIdle()},3e4),this._lastUsedTime=0,this._configChangeListener=this._defaults.onDidChange(function(){return n._stopWorker()})}return e.prototype._stopWorker=function(){this._worker&&(this._worker.dispose(),this._worker=null),this._client=null},e.prototype.dispose=function(){clearInterval(this._idleCheckInterval),this._configChangeListener.dispose(),this._stopWorker()},e.prototype._checkIfIdle=function(){if(this._worker){var e=this._defaults.getWorkerMaxIdleTime(),t=Date.now()-this._lastUsedTime;e>0&&t>e&&this._stopWorker()}},e.prototype._getClient=function(){return this._lastUsedTime=Date.now(),this._client||(this._worker=monaco.editor.createWebWorker({moduleId:"vs/language/typescript/src/worker",label:this._modeId,createData:{compilerOptions:this._defaults.getCompilerOptions(),extraLibs:this._defaults.getExtraLibs()}}),this._client=this._worker.getProxy()),this._client},e.prototype.getLanguageServiceWorker=function(){for(var e=this,t=[],r=0;r<arguments.length;r++)t[r]=arguments[r];var o;return n(this._getClient().then(function(e){o=e}).then(function(n){return e._worker.withSyncedResources(t)}).then(function(e){return o}))},e}();t.WorkerManager=o});var __extends=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)};define("vs/language/typescript/src/languageFeatures",["require","exports","../lib/typescriptServices"],function(e,t,n){"use strict";function r(e,t){return e.onCancellationRequested(function(){return t.cancel()}),t}var o=monaco.Uri,i=monaco.Position,a=monaco.Promise,s={"For Loop":{prefix:"for",body:["for (let index = 0; index <= 4; index++) {","\t$0","}"],description:"For Loop"},"If Statement":{prefix:"if",body:["if (${condition}) {","\t$0","}"],description:"If Statement"},"While Statement":{prefix:"while",body:["while (${condition}) {","\t$0","}"],description:"While Statement"}},c=function(){function e(e){this._worker=e}return e.prototype._positionToOffset=function(e,t){var n=monaco.editor.getModel(e);return n.getOffsetAt(t)},e.prototype._offsetToPosition=function(e,t){var n=monaco.editor.getModel(e);return n.getPositionAt(t)},e.prototype._textSpanToRange=function(e,t){var n=this._offsetToPosition(e,t.start),r=this._offsetToPosition(e,t.start+t.length),o=n.lineNumber,i=n.column,a=r.lineNumber,s=r.column;return{startLineNumber:o,startColumn:i,endLineNumber:a,endColumn:s}},e}();t.Adapter=c;var u=function(e){function t(t,n,r){var o=e.call(this,r)||this;o._defaults=t,o._selector=n,o._disposables=[],o._listener=Object.create(null);var i=function(e){if(e.getModeId()===n){var t,r=e.onDidChangeContent(function(){clearTimeout(t),t=setTimeout(function(){return o._doValidate(e.uri)},500)});o._listener[e.uri.toString()]={dispose:function(){r.dispose(),clearTimeout(t)}},o._doValidate(e.uri)}},a=function(e){monaco.editor.setModelMarkers(e,o._selector,[]);var t=e.uri.toString();o._listener[t]&&(o._listener[t].dispose(),delete o._listener[t])};return o._disposables.push(monaco.editor.onDidCreateModel(i)),o._disposables.push(monaco.editor.onWillDisposeModel(a)),o._disposables.push(monaco.editor.onDidChangeModelLanguage(function(e){a(e.model),i(e.model)})),o._disposables.push({dispose:function(){for(var e=0,t=monaco.editor.getModels();e<t.length;e++){var n=t[e];a(n)}}}),o._disposables.push(o._defaults.onDidChange(function(){for(var e=0,t=monaco.editor.getModels();e<t.length;e++){var n=t[e];a(n),i(n)}})),monaco.editor.getModels().forEach(i),o}return __extends(t,e),t.prototype.dispose=function(){this._disposables.forEach(function(e){return e&&e.dispose()}),this._disposables=[]},t.prototype._doValidate=function(e){var t=this;this._worker(e).then(function(n){var r=[],o=t._defaults.getDiagnosticsOptions(),i=o.noSyntaxValidation,s=o.noSemanticValidation;return i||r.push(n.getSyntacticDiagnostics(e.toString())),s||r.push(n.getSemanticDiagnostics(e.toString())),a.join(r)}).then(function(n){var r=n.reduce(function(e,t){return t.concat(e)},[]).map(function(n){return t._convertDiagnostics(e,n)});monaco.editor.setModelMarkers(monaco.editor.getModel(e),t._selector,r)}).done(void 0,function(e){console.error(e)})},t.prototype._convertDiagnostics=function(e,t){var r=this._offsetToPosition(e,t.start),o=r.lineNumber,i=r.column,a=this._offsetToPosition(e,t.start+t.length),s=a.lineNumber,c=a.column;return{severity:monaco.Severity.Error,startLineNumber:o,startColumn:i,endLineNumber:s,endColumn:c,message:n.flattenDiagnosticMessageText(t.messageText,"\n")}},t}(c);t.DiagnostcsAdapter=u;var l=function(e){function t(t){var n=e.call(this,t)||this;return n.typescriptSnippets=[],n.exclusionMap=Object.create(null),n.exclusionMap.from=1,n.exclusionMap["import"]=1,n.exclusionMap["delete"]=1,n.exclusionMap["with"]=1,n.exclusionMap.await=1,n.exclusionMap["try"]=1,n.exclusionMap["catch"]=1,n.exclusionMap["finally"]=1,n.exclusionMap["yield"]=1,n.exclusionMap.as=1,n.exclusionMap.async=1,n.exclusionMap.any=1,Object.keys(s).forEach(function(e){var t=s[e],r=t.prefix,o="";t.body.forEach(function(e){o+=e.replace("$0","{{}}").replace(/\${(.*?)}/gi,"{{$1}}")+"\n"});var i=t.description;n.typescriptSnippets.push({prefix:r,body:o,description:i})}),n}return __extends(t,e),Object.defineProperty(t.prototype,"triggerCharacters",{get:function(){return["."]},enumerable:!0,configurable:!0}),t.prototype.provideCompletionItems=function(e,n,o){var s=this,c=e.getWordUntilPosition(n),u=e.uri,l=this._positionToOffset(u,n),p=e.getLineContent(n.lineNumber),m=e.getWordAtPosition(n),d="",g="";m&&(d=p.substring(m.startColumn-1,n.column-1),g=p.substring(n.column-1,m.endColumn-1));var f=(p.substr(0,n.column-1),p.substr(n.column-1)),h=!1,S=e.getWordUntilPosition(new i(n.lineNumber,c.startColumn-1));return S&&S.word&&""!=S.word&&(h=!0),r(o,this._worker(u).then(function(e){var r=[];r.push(e.getCompletionsAtPosition(u.toString(),l));var o=e.getNavigateToItems(c.word).then(function(e){function r(e,r){var o=r.containerName?r.containerName+"."+r.name:r.name,i={uri:u,position:n,label:o,name:r.name,sortText:r.name,filterText:(h?S.word+".":"")+r.name,kind:t.convertKind(r.kind),containerName:r.containerName,navigation:r,skipCodeSnippet:""!=f.trim(),textEdit:{text:(h?S.word+".":"")+r.name,range:new monaco.Range(n.lineNumber,n.column-c.word.length-(h?S.word.length+1:0),n.lineNumber,n.column)}};e.push(i)}if(!e||0==e.length)return[];var o=[];return e.filter(function(e){return e.kind==v["function"]&&""!=e.kindModifiers&&(!h||e.containerName!=S.word)}).forEach(function(e){return r(o,e)}),o});return r.push(o),a.join(r)}).then(function(e){if(e){var r=e[0],o=e[1];if(r){var i=r.entries.filter(function(e){return!s.exclusionMap[e.name]}).map(function(e){return{uri:u,position:n,label:e.name,name:e.name,sortText:e.sortText,kind:t.convertKind(e.kind),skipCodeSnippet:""!=f.trim()}});return o&&(i=i.concat(o)),i}}}))},t.prototype.resolveCompletionItem=function(e,o){var i=this,s=e,c=s.uri,u=s.position,l=this.typescriptSnippets.filter(function(e){return e.prefix==s.label})[0];return l?new a(function(e,t){s.insertText=l.body,s.documentation=l.description,e(s)}):r(o,this._worker(c).then(function(e){return s.navigation?e.getCompletionEntryDetailsAndSnippet(s.navigation.fileName,s.navigation.textSpan.start,s.name,s.label):e.getCompletionEntryDetailsAndSnippet(c.toString(),i._positionToOffset(c,u),s.name,s.label)}).then(function(e){if(!e)return s;var r=e[0],o=e[1];return r?(s.uri=c,s.position=u,s.kind=t.convertKind(r.kind),s.detail=n.displayPartsToString(r.displayParts),s.documentation=n.displayPartsToString(r.documentation),s.insertText=s.skipCodeSnippet?null:o,s):s}))},t.convertKind=function(e){switch(e){case v.primitiveType:case v.keyword:return monaco.languages.CompletionItemKind.Keyword;case v.variable:case v.localVariable:return monaco.languages.CompletionItemKind.Variable;case v.memberVariable:case v.memberGetAccessor:case v.memberSetAccessor:return monaco.languages.CompletionItemKind.Field;case v["function"]:case v.memberFunction:case v.constructSignature:case v.callSignature:case v.indexSignature:return monaco.languages.CompletionItemKind.Function;case v["enum"]:return monaco.languages.CompletionItemKind.Enum;case v.module:return monaco.languages.CompletionItemKind.Module;case v["class"]:return monaco.languages.CompletionItemKind.Class;case v["interface"]:return monaco.languages.CompletionItemKind.Interface;case v.warning:return monaco.languages.CompletionItemKind.File}return monaco.languages.CompletionItemKind.Property},t}(c);t.SuggestAdapter=l;var p=function(e){function t(){var t=null!==e&&e.apply(this,arguments)||this;return t.signatureHelpTriggerCharacters=["(",","],t}return __extends(t,e),t.prototype.provideSignatureHelp=function(e,t,o){var i=this,a=e.uri;return r(o,this._worker(a).then(function(e){return e.getSignatureHelpItems(a.toString(),i._positionToOffset(a,t))}).then(function(e){if(e){var t={activeSignature:e.selectedItemIndex,activeParameter:e.argumentIndex,signatures:[]};return e.items.forEach(function(e){var r={label:"",documentation:null,parameters:[]};r.label+=n.displayPartsToString(e.prefixDisplayParts),e.parameters.forEach(function(t,o,i){var a=n.displayPartsToString(t.displayParts),s={label:a,documentation:n.displayPartsToString(t.documentation)};r.label+=a,r.parameters.push(s),o<i.length-1&&(r.label+=n.displayPartsToString(e.separatorDisplayParts))}),r.label+=n.displayPartsToString(e.suffixDisplayParts),t.signatures.push(r)}),t}}))},t}(c);t.SignatureHelpAdapter=p;var m=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),t.prototype.provideHover=function(e,t,o){var i=this,s=e.uri,c=e.getWordAtPosition(t);return r(o,this._worker(s).then(function(e){var n=[];return n.push(e.getQuickInfoAtPosition(s.toString(),i._positionToOffset(s,t))),n.push(e.getSignatureHelpItems(s.toString(),i._positionToOffset(s,t))),c&&n.push(e.getCompletionEntryDetails(s.toString(),i._positionToOffset(s,t),c.word)),a.join(n)}).then(function(t){if(t){var r=t[0],o=t[1],a=t[2];if(r&&a){var c=n.displayPartsToString(a.documentation);return c||(c=n.displayPartsToString(r.displayParts)),{range:i._textSpanToRange(s,r.textSpan),contents:[c]}}if(o&&o.items[0]){if(o.items[0].parameters.length>0){var u=o.argumentIndex,c=n.displayPartsToString(o.items[0].parameters[u].documentation);c||(c=n.displayPartsToString(o.items[0].parameters[u].displayParts));var l=o.applicableSpan;if(o.argumentCount>1){var p=e.getValue().substr(o.applicableSpan.start,o.applicableSpan.length),m=p.split(",");l.start=l.start+p.indexOf(m[u]),l.length=m[u].length}return{range:i._textSpanToRange(s,l),contents:[c]}}}else if(r){var c=n.displayPartsToString(r.displayParts);return{range:i._textSpanToRange(s,r.textSpan),contents:[c]}}}}))},t}(c);t.QuickInfoAdapter=m;var d=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),t.prototype.provideDocumentHighlights=function(e,t,n){var o=this,i=e.uri;return r(n,this._worker(i).then(function(e){return e.getOccurrencesAtPosition(i.toString(),o._positionToOffset(i,t))}).then(function(e){if(e)return e.map(function(e){return{range:o._textSpanToRange(i,e.textSpan),kind:e.isWriteAccess?monaco.languages.DocumentHighlightKind.Write:monaco.languages.DocumentHighlightKind.Text}})}))},t}(c);t.OccurrencesAdapter=d;var g=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),t.prototype.provideDefinition=function(e,t,n){var i=this,a=e.uri;return r(n,this._worker(a).then(function(e){return e.getDefinitionAtPosition(a.toString(),i._positionToOffset(a,t))}).then(function(e){if(e){for(var t=[],n=0,r=e;n<r.length;n++){var a=r[n],s=o.parse(a.fileName);monaco.editor.getModel(s)&&t.push({uri:s,range:i._textSpanToRange(s,a.textSpan)})}return t}}))},t}(c);t.DefinitionAdapter=g;var f=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),t.prototype.provideReferences=function(e,t,n,i){var a=this,s=e.uri;return r(i,this._worker(s).then(function(e){return e.getReferencesAtPosition(s.toString(),a._positionToOffset(s,t))}).then(function(e){if(e){for(var t=[],n=0,r=e;n<r.length;n++){var i=r[n],s=o.parse(i.fileName);monaco.editor.getModel(s)&&t.push({uri:s,range:a._textSpanToRange(s,i.textSpan)})}return t}}))},t}(c);t.ReferenceAdapter=f;var h=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),t.prototype.provideDocumentSymbols=function(e,t){var n=this,o=e.uri;return r(t,this._worker(o).then(function(e){return e.getNavigationBarItems(o.toString())}).then(function(e){if(e){var t=function(e,r,i){var a={name:r.text,kind:S[r.kind]||monaco.languages.SymbolKind.Variable,location:{uri:o,range:n._textSpanToRange(o,r.spans[0])},containerName:i};if(r.childItems&&r.childItems.length>0)for(var s=0,c=r.childItems;s<c.length;s++){var u=c[s];t(e,u,a.name)}e.push(a)},r=[];return e.forEach(function(e){return t(r,e)}),r}}))},t}(c);t.OutlineAdapter=h;var v=function(){function e(){}return e}();v.unknown="",v.keyword="keyword",v.script="script",v.module="module",v["class"]="class",v["interface"]="interface",v.type="type",v["enum"]="enum",v.variable="var",v.localVariable="local var",v["function"]="function",v.localFunction="local function",v.memberFunction="method",v.memberGetAccessor="getter",v.memberSetAccessor="setter",v.memberVariable="property",v.constructorImplementation="constructor",v.callSignature="call",v.indexSignature="index",v.constructSignature="construct",v.parameter="parameter",v.typeParameter="type parameter",v.primitiveType="primitive type",v.label="label",v.alias="alias",v["const"]="const",v["let"]="let",v.warning="warning",t.Kind=v;var S=Object.create(null);S[v.module]=monaco.languages.SymbolKind.Module,S[v["class"]]=monaco.languages.SymbolKind.Class,S[v["enum"]]=monaco.languages.SymbolKind.Enum,S[v["interface"]]=monaco.languages.SymbolKind.Interface,S[v.memberFunction]=monaco.languages.SymbolKind.Method,S[v.memberVariable]=monaco.languages.SymbolKind.Property,S[v.memberGetAccessor]=monaco.languages.SymbolKind.Property,S[v.memberSetAccessor]=monaco.languages.SymbolKind.Property,S[v.variable]=monaco.languages.SymbolKind.Variable,S[v["const"]]=monaco.languages.SymbolKind.Variable,S[v.localVariable]=monaco.languages.SymbolKind.Variable,S[v.variable]=monaco.languages.SymbolKind.Variable,S[v["function"]]=monaco.languages.SymbolKind.Function,S[v.localFunction]=monaco.languages.SymbolKind.Function;var y=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),t._convertOptions=function(e){return{ConvertTabsToSpaces:e.insertSpaces,TabSize:e.tabSize,IndentSize:e.tabSize,IndentStyle:n.IndentStyle.Smart,NewLineCharacter:"\n",InsertSpaceAfterCommaDelimiter:!0,InsertSpaceAfterSemicolonInForStatements:!0,InsertSpaceBeforeAndAfterBinaryOperators:!0,InsertSpaceAfterKeywordsInControlFlowStatements:!0,InsertSpaceAfterFunctionKeywordForAnonymousFunctions:!0,InsertSpaceAfterOpeningAndBeforeClosingNonemptyParenthesis:!1,InsertSpaceAfterOpeningAndBeforeClosingNonemptyBrackets:!1,InsertSpaceAfterOpeningAndBeforeClosingTemplateStringBraces:!1,PlaceOpenBraceOnNewLineForControlBlocks:!1,PlaceOpenBraceOnNewLineForFunctions:!1}},t.prototype._convertTextChanges=function(e,t){return{text:t.newText,range:this._textSpanToRange(e,t.span)}},t}(c);t.FormatHelper=y;var b=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),t.prototype.provideDocumentRangeFormattingEdits=function(e,t,n,o){var i=this,a=e.uri;return r(o,this._worker(a).then(function(e){return e.getFormattingEditsForRange(a.toString(),i._positionToOffset(a,{lineNumber:t.startLineNumber,column:t.startColumn}),i._positionToOffset(a,{lineNumber:t.endLineNumber,column:t.endColumn}),y._convertOptions(n))}).then(function(e){if(e)return e.map(function(e){return i._convertTextChanges(a,e)})}))},t}(y);t.FormatAdapter=b;var _=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),Object.defineProperty(t.prototype,"autoFormatTriggerCharacters",{get:function(){return[";","}","\n"]},enumerable:!0,configurable:!0}),t.prototype.provideOnTypeFormattingEdits=function(e,t,n,o,i){var a=this,s=e.uri;return r(i,this._worker(s).then(function(e){return e.getFormattingEditsAfterKeystroke(s.toString(),a._positionToOffset(s,t),n,y._convertOptions(o))}).then(function(e){if(e)return e.map(function(e){return a._convertTextChanges(s,e)})}))},t}(y);t.FormatOnTypeAdapter=_}),define("vs/language/typescript/src/mode",["require","exports","./tokenization","./workerManager","./languageFeatures"],function(e,t,n,r,o){"use strict";function i(e){p=u(e,"typescript",n.Language.TypeScript)}function a(e){l=u(e,"javascript",n.Language.EcmaScript5)}function s(){return new monaco.Promise(function(e,t){return l?void e(l):t("JavaScript not registered!")})}function c(){return new monaco.Promise(function(e,t){return p?void e(p):t("TypeScript not registered!")})}function u(e,t,i){var a=[],s=new r.WorkerManager(t,e);a.push(s);var c=function(e){for(var t=[],n=1;n<arguments.length;n++)t[n-1]=arguments[n];return s.getLanguageServiceWorker.apply(s,[e].concat(t))};return a.push(monaco.languages.registerCompletionItemProvider(t,new o.SuggestAdapter(c))),a.push(monaco.languages.registerSignatureHelpProvider(t,new o.SignatureHelpAdapter(c))),a.push(monaco.languages.registerHoverProvider(t,new o.QuickInfoAdapter(c))),a.push(monaco.languages.registerDocumentHighlightProvider(t,new o.OccurrencesAdapter(c))),a.push(monaco.languages.registerDefinitionProvider(t,new o.DefinitionAdapter(c))),a.push(monaco.languages.registerReferenceProvider(t,new o.ReferenceAdapter(c))),a.push(monaco.languages.registerDocumentSymbolProvider(t,new o.OutlineAdapter(c))),a.push(monaco.languages.registerDocumentRangeFormattingEditProvider(t,new o.FormatAdapter(c))),a.push(monaco.languages.registerOnTypeFormattingEditProvider(t,new o.FormatOnTypeAdapter(c))),a.push(new o.DiagnostcsAdapter(e,t,c)),a.push(monaco.languages.setLanguageConfiguration(t,m)),a.push(monaco.languages.setTokensProvider(t,n.createTokenizationSupport(i))),c}var l,p;t.setupTypeScript=i,t.setupJavaScript=a,t.getJavaScriptWorker=s,t.getTypeScriptWorker=c;var m={wordPattern:/(-?\d*\.\d\w*)|([^\`\~\!\@\#\%\^\&\*\(\)\-\=\+\[\{\]\}\\\|\;\:\'\"\,\.\<\>\/\?\s]+)/g,comments:{lineComment:"//",blockComment:["/*","*/"]},brackets:[["{","}"],["[","]"],["(",")"]],onEnterRules:[{beforeText:/^\s*\/\*\*(?!\/)([^\*]|\*(?!\/))*$/,afterText:/^\s*\*\/$/,action:{indentAction:monaco.languages.IndentAction.IndentOutdent,appendText:" * "}},{beforeText:/^\s*\/\*\*(?!\/)([^\*]|\*(?!\/))*$/,action:{indentAction:monaco.languages.IndentAction.None,appendText:" * "}},{beforeText:/^(\t|(\ \ ))*\ \*(\ ([^\*]|\*(?!\/))*)?$/,action:{indentAction:monaco.languages.IndentAction.None,appendText:"* "}},{beforeText:/^(\t|(\ \ ))*\ \*\/\s*$/,action:{indentAction:monaco.languages.IndentAction.None,removeText:1}}],autoClosingPairs:[{open:"{",close:"}"},{open:"[",close:"]"},{open:"(",close:")"},{open:'"',close:'"',notIn:["string"]},{open:"'",close:"'",notIn:["string","comment"]},{open:"`",close:"`",notIn:["string","comment"]},{open:"/**",close:" */",notIn:["string"]}]}});